{

  SPINEL - knihovna obecnch funkc  
   
  Vydavatel: Papouch s.r.o. - http://www.papouch.com/spinel/

}

unit uSpinel;

interface

type 
  TSpinelFormat = (S65 = 65, S97 = 97);
  
const
  sACK_Ok = $00;            // Ok
  sACK_packet_short = $01;  // Pli krtk paket
  sACK_invalid_PRE = $02;   // Neplatn prefix paketu (PRE)
  sACK_invalid_FRM = $03;   // Paket m jin pznak formatu (FRM)
  sACK_invalid_NUM = $04;   // Chybn dlka paketu (NUM)       [S97 only]
  sACK_invalid_CRC = $05;   // Chybn kontroln souet (CRC)   [S97 only]
  sACK_invalid_CR = $06;    // Neplatn koncov znak (CR)

function DetectSpinelPacket(Data:String):Byte;
function GetSpinelMessage(var Data:String; DelData:Boolean=False):String;
function EncodeSpinelPacket(FRM:byte; ADR:Char; SIG:byte; INST:byte; DATA:String):String;

implementation

uses uSpinel65, uSpinel97, SysUtils;

function DetectSpinelPacket(Data:String):Byte;
Var S:String;
begin
  Result:=0;
  If Length(Data)>8 then
   If sChecek_S97(sGetPacket_S97(Data,False))=0 then Result:=97 else
   If sChecek_S65(sGetPacket_S65(Data,False))=0 then Result:=65;
end;

function GetSpinelMessage(Var Data:String; DelData:Boolean):String;
begin
  Result:='';
  Case DetectSpinelPacket(Data) of
   65: Result:=sGetPacket_S65(Data,DelData);
   97: Result:=sGetPacket_S97(Data,DelData);
  end;
end;

function EncodeSpinelPacket(FRM:byte; ADR:Char; SIG:byte; INST:byte; DATA:String):String;
begin
  Result:='';
  Case FRM of
   65: Result:=sEncode_S65(ADR,SIG,INST,DATA);
   97: Result:=sEncode_S97(ADR,SIG,INST,DATA);
  end;
end;

end.
